

#if !defined __SDSI_H
#define __SDSI_H


#include "matrix.h"


#define PCIG_VIEWPOINT_C01      0x00000001
#define PCIG_VIEWPOINT_C02      0x00000002
#define PCIG_VIEWPOINT_C03      0x00000004
#define PCIG_VIEWPOINT_C04      0x00000008
#define PCIG_VIEWPOINT_C05      0x00000010
#define PCIG_VIEWPOINT_C06      0x00000020
#define PCIG_VIEWPOINT_C07      0x00000040
#define PCIG_VIEWPOINT_C08      0x00000080
#define PCIG_VIEWPOINT_C09      0x00000100
#define PCIG_VIEWPOINT_C10      0x00000200
#define PCIG_VIEWPOINT_C11      0x00000400
#define PCIG_VIEWPOINT_C12      0x00000800
#define PCIG_VIEWPOINT_C13      0x00001000
#define PCIG_VIEWPOINT_C14      0x00002000
#define PCIG_VIEWPOINT_C15      0x00004000
#define PCIG_VIEWPOINT_C16      0x00008000
#define PCIG_VIEWPOINT_MAVERICK 0x10000000
#define PCIG_VIEWPOINT_HELMET   0x20000000
#define PCIG_VIEWPOINT_ALL      0xffffffff

#define PCIG_FOG_LINEAR 0x01  // fog, fog2
#define PCIG_FOG_EXP    0x02  // fog, fog2
#define PCIG_FOG_EXP2   0x03  // fog, fog2
#define PCIG_FOG_HAZE   0x04  // fog2
#define PCIG_FOG_DIST   0x05  // fog2
#define PCIG_FOG_GRND   0x06  // fog2

#define PCIG_PRECIP_RAIN          0x01
#define PCIG_PRECIP_SNOW          0x02

#define PCIG_SKY_INFINITE         0x0001
#define PCIG_SKY_AUTO_COLOR       0x0002
#define PCIG_SKY_LENS_FLARE       0x0004
#define PCIG_SKY_SKY              0x0008
#define PCIG_SKY_GROUND           0x0010
#define PCIG_SKY_HORIZONTAL       0x0020
#define PCIG_SKY_SKY_HORIZON_LINE 0x0040

#define PCIG_STATUS_DAMAGED       0x001
#define PCIG_STATUS_DESTROYED     0x002
#define PCIG_STATUS_CLAMP         0x004
#define PCIG_STATUS_FIRING        0x008

#define PCIG_ARTICULATION_RUDDER         1024
#define PCIG_ARTICULATION_FLAPS          1056
#define PCIG_ARTICULATION_AILERONS       1120
#define PCIG_ARTICULATION_GEAR           3072
#define PCIG_ARTICULATION_HOOK           3104
#define PCIG_ARTICULATION_BRAKE          3136
#define PCIG_ARTICULATION_LEFT_BAY_DOOR  3168
#define PCIG_ARTICULATION_RIGHT_BAY_DOOR 3200
#define PCIG_ARTICULATION_HATCH          3232
#define PCIG_ARTICULATION_TURRENT1       4096
#define PCIG_ARTICULATION_GUN1           4416
#define PCIG_ARTICULATION_TURRENT2       5696
#define PCIG_ARTICULATION_GUN2           6016

#define PCIG_SFX_TYPE_EXPLOSION 0x01
#define PCIG_SFX_TYPE_TRAIL     0x02
#define PCIG_SFX_TYPE_FIRE      0x03
#define PCIG_SFX_TYPE_SMOKE     0x04

#define PCIG_SFX_SUBTYPE_EXPLOSION_GROUND_LARGE       100
#define PCIG_SFX_SUBTYPE_EXPLOSION_GROUND_MEDIUM      101
#define PCIG_SFX_SUBTYPE_EXPLOSION_GROUND_SMALL       102
#define PCIG_SFX_SUBTYPE_EXPLOSION_PHOSPHOROUS_LARGE  110
#define PCIG_SFX_SUBTYPE_EXPLOSION_PHOSPHOROUS_SMALL  111
#define PCIG_SFX_SUBTYPE_EXPLOSION_BULLET_DIRT        120
#define PCIG_SFX_SUBTYPE_EXPLOSION_BULLET_SPARKLE     130
#define PCIG_SFX_SUBTYPE_EXPLOSION_ARMOUR_SINGLE      140
#define PCIG_SFX_SUBTYPE_EXPLOSION_ARMOUR_CLUSTER     150
#define PCIG_SFX_SUBTYPE_EXPLOSION_FIREBALL_LARGE     200
#define PCIG_SFX_SUBTYPE_EXPLOSION_FIREBALL_MEDIUM    201
#define PCIG_SFX_SUBTYPE_EXPLOSION_FLAK               210

#define PCIG_SFX_SUBTYPE_TRAIL_SMOKE  1
#define PCIG_SFX_SUBTYPE_TRAIL_DUST   2

#define PCIG_SFX_SUBTYPE_FIRE 1

#define PCIG_SFX_SUBTYPE_SMOKE_THICK_BALL    1
#define PCIG_SFX_SUBTYPE_SMOKE_HEAVY_BALL    2
#define PCIG_SFX_SUBTYPE_SMOKE_MEDIUM_BALL   3
#define PCIG_SFX_SUBTYPE_SMOKE_LIGHT_BALL    4
#define PCIG_SFX_SUBTYPE_SMOKE_THICK_PLUME   5
#define PCIG_SFX_SUBTYPE_SMOKE_HEAVY_PLUME   6
#define PCIG_SFX_SUBTYPE_SMOKE_MEDIUM_PLUME  7
#define PCIG_SFX_SUBTYPE_SMOKE_LIGHT_PLUME   8
#define PCIG_SFX_SUBTYPE_SMOKE_DUST          9
#define PCIG_SFX_SUBTYPE_SMOKE_WHITE        10
#define PCIG_SFX_SUBTYPE_SMOKE_RED          11
#define PCIG_SFX_SUBTYPE_SMOKE_GREEN        12
#define PCIG_SFX_SUBTYPE_SMOKE_GENERATOR    13

#define PCIG_LIGHT_EDGE   0x00000001
#define PCIG_LIGHT_RCLS   0x00000002
#define PCIG_LIGHT_TDZL   0x00000004
#define PCIG_LIGHT_ALS    0x00000008
#define PCIG_LIGHT_REIL   0x00000010
#define PCIG_LIGHT_VASI   0x00000020
#define PCIG_LIGHT_PAPI   0x00000040
#define PCIG_LIGHT_TRI    0x00000080
#define PCIG_LIGHT_PULSE  0x00000100
#define PCIG_LIGHT_BEAC   0x00000200
#define PCIG_LIGHT_TAXI   0x00000400
#define PCIG_LIGHT_ALL    0xffffffff

#define PCIG_GFX_VEHICLE_DUST 0x00000001

#define PCIG_OF_NODETYPE_DOF    0x01
#define PCIG_OF_NODETYPE_SWITCH 0x02
#define PCIG_OF_NODETYPE_TEXT   0x03
#define PCIG_OF_NODETYPE_COLOR  0x04
#define PCIG_OF_NODETYPE_SCALE  0x05

#define PCIG_SENSOR_SELECT_DISABLE           0x00
#define PCIG_SENSOR_SELECT_INTENSIFY_GENERIC 0x01
#define PCIG_SENSOR_SELECT_INTENSIFY_PVS7    0x02
#define PCIG_SENSOR_SELECT_INTENSIFY_VVS2    0x03
#define PCIG_SENSOR_SELECT_THERMAL_GENERIC   0x04
#define PCIG_SENSOR_SELECT_THERMAL_M1A1      0x05
#define PCIG_SENSOR_SELECT_THERMAL_M2A2      0x06

#define PCIG_INTERVISIBILITY_ENTITIES 0x0001
#define PCIG_INTERVISIBILITY_TERRAIN  0x0002
#define PCIG_INTERVISIBILITY_SFX      0x0004

#define PCIG_TYPE_VIEWPORT       200
#define PCIG_TYPE_CHANNEL        201
#define PCIG_TYPE_CAMERA         202
#define PCIG_TYPE_TERRAIN        203
#define PCIG_TYPE_VIEWPOINT      301
#define PCIG_TYPE_ENDSIM         302
#define PCIG_TYPE_VIEWPOINT_LLA  303
#define PCIG_TYPE_FOG            500
#define PCIG_TYPE_CLOUD          501
#define PCIG_TYPE_TIME           502
#define PCIG_TYPE_SKY            503
#define PCIG_TYPE_VISIBILITY     504
#define PCIG_TYPE_WIND           505
#define PCIG_TYPE_RUNWAY_VISUAL_RANGE 506
#define PCIG_TYPE_FOG2           507
#define PCIG_TYPE_CLOUD2         508
#define PCIG_TYPE_TIME2          509
#define PCIG_TYPE_ENTITY_UPDATE  600
#define PCIG_TYPE_STATUS_UPDATE  601
#define PCIG_TYPE_ARTICULATION   602
#define PCIG_TYPE_ENTITY_ARTICULATION_UPDATE 603
#define PCIG_TYPE_MUNITIONS      604
#define PCIG_TYPE_ENTITY_REMOVAL 605
#define PCIG_TYPE_ENTITY_LLA_UPDATE 606
#define PCIG_TYPE_STATUS_UPDATE_LLA 607
#define PCIG_TYPE_SFX            700
#define PCIG_TYPE_SFX_LLA        701
#define PCIG_TYPE_RUNWAY_LIGHTS  705
#define PCIG_TYPE_GFX            706
#define PCIG_TYPE_REMOVE_ALL     800
#define PCIG_TYPE_LAZER_RANGE_FIND 1000
#define PCIG_TYPE_TERRAIN_HEIGHT   1001
#define PCIG_TYPE_GEOMETRIC_INTERVISIBILITY 1002
#define PCIG_TYPE_TERRAIN_HEIGHT2  1008
#define PCIG_TYPE_FRAME_RESPONSE   2000
#define PCIG_TYPE_LAZER_RANGE_FIND_RESPONSE 2001
#define PCIG_TYPE_TERRAIN_HEIGHT_RESPONSE  2002
#define PCIG_TYPE_GEOMETRIC_INTERVISIBILITY_RESPONSE 2003
#define PCIG_TYPE_COLLISION_DETECTION_RESPONSE 2004
#define PCIG_TYPE_FRAME_RESPONSE_DETAILED  2005
#define PCIG_TYPE_TERRAIN_HEIGHT_RESPONSE2 2006
#define PCIG_TYPE_READY_TO_RENDER  2007
#define PCIG_TYPE_OGL_OVERLAY      4002
#define PCIG_TYPE_OF_OVERLAY       4003
#define PCIG_TYPE_SENSOR_SELECT    5000
#define PCIG_TYPE_SENSOR_ENV       5001
#define PCIG_TYPE_SENSOR_CHARACTERISTICS 5002

#define PCIG_SIZE_VIEWPORT          32
#define PCIG_SIZE_CHANNEL           48
#define PCIG_SIZE_CAMERA            64
#define PCIG_SIZE_TERRAIN           16
#define PCIG_SIZE_VIEWPOINT         56
#define PCIG_SIZE_ENDSIM            8
#define PCIG_SIZE_VIEWPOINT_LLA     56
//#define PCIG_SIZE_FOG               36
#define PCIG_SIZE_FOG               48
#define PCIG_SIZE_CLOUD             48
#define PCIG_SIZE_TIME              24
//#define PCIG_SIZE_SKY               24
#define PCIG_SIZE_SKY               32
#define PCIG_SIZE_VISIBILITY        16
#define PCIG_SIZE_WIND              32
#define PCIG_SIZE_RUNWAY_VISUAL_RANGE 32
#define PCIG_SIZE_FOG2              48
#define PCIG_SIZE_CLOUD2            64
#define PCIG_SIZE_TIME2             40
#define PCIG_SIZE_ENTITY_UPDATE     56
#define PCIG_SIZE_STATUS_UPDATE     72
#define PCIG_SIZE_ARTICULATION_BASE 16
#define PCIG_SIZE_ENTITY_ARTICULATION_UPDATE_BASE 52
#define PCIG_SIZE_MUNITIONS         16
#define PCIG_SIZE_ENTITY_REMOVAL    16
#define PCIG_SIZE_ENTITY_LLA_UPDATE 56
#define PCIG_SIZE_STATUS_UPDATE_LLA 72
#define PCIG_SIZE_SFX               64
#define PCIG_SIZE_SFX_LLA           64
#define PCIG_SIZE_RUNWAY_LIGHTS     24
#define PCIG_SIZE_GFX               16
#define PCIG_SIZE_REMOVE_ALL        8
#define PCIG_SIZE_LAZER_RANGE_FIND  48
#define PCIG_SIZE_TERRAIN_HEIGHT    40
#define PCIG_SIZE_GEOMETRIC_INTERVISIBILITY 72
#define PCIG_SIZE_TERRAIN_HEIGHT2   40
#define PCIG_SIZE_FRAME_RESPONSE    24
#define PCIG_SIZE_LAZER_RANGE_FIND_RESPONSE 64
#define PCIG_SIZE_TERRAIN_HEIGHT_RESPONSE 16
#define PCIG_SIZE_GEOMETRIC_INTERVISIBILITY_RESPONSE 64
#define PCIG_SIZE_COLLISION_DETECTION_RESPONSE 56
#define PCIG_SIZE_FRAME_RESPONSE_DETAILED 40
#define PCIG_SIZE_TERRAIN_HEIGHT_RESPONSE2 40
#define PCIG_SIZE_READY_TO_RENDER   8
#define PCIG_SIZE_OGL_OVERLAY_BASE  16
#define PCIG_SIZE_OF_OVERLAY_BASE   24
#define PCIG_SIZE_SENSOR_SELECT     16
#define PCIG_SIZE_SENSOR_ENV_BASE   24
#define PCIG_SIZE_SENSOR_CHARACTERISTICS 64


typedef struct {

   int type;
   int size;
} PCIG_header_type;


typedef struct {

   vector3d xyz;  // meters from center of scenario
} PCIG_position3d_type;


typedef struct {

   double lat;  // radians +/-HALFPI
   double lon;  // radians +/-PI
   double alt;  // meters msl
} PCIG_lla_type;


typedef struct {

   vector3f pyr;  // x-p, y-y, z-r,  radians
} PCIG_orientation_type;


typedef struct {

   vector3f rgba;  // (0..1)
} PCIG_color_type;


typedef struct {

   vector2f xy;  // 2d screen coords (-1..1)
} PCIG_position2d_type;


typedef struct {

   vector2f xy;
} PCIG_scale2d_type;


typedef struct pcig_viewpoint_struct {

   PCIG_header_type header;
   int viewpoint_id;          // PCIG_VIEWPOINT_XXXX
   int clamp_flag;            // if set, slap object to the ground
   PCIG_position3d_type pos;
   PCIG_orientation_type orient;
   int padd;

   pcig_viewpoint_struct() { header.type = PCIG_TYPE_VIEWPOINT; header.size = PCIG_SIZE_VIEWPOINT; }
} PCIG_viewpoint_type;


typedef struct pcig_endsim_struct {

   PCIG_header_type header;
   
   pcig_endsim_struct() { header.type = PCIG_TYPE_ENDSIM; header.size = PCIG_SIZE_ENDSIM; }
} PCIG_endsim_type;


typedef struct pcig_viewpoint_lla_struct {

   PCIG_header_type header;
   int viewpoint_id;          // PCIG_VIEWPOINT_XXXX
   int clamp_flag;            // if set, slap object to the ground
   PCIG_lla_type pos;
   PCIG_orientation_type orient;
   int padd;

   pcig_viewpoint_lla_struct() { header.type = PCIG_TYPE_VIEWPOINT_LLA; header.size = PCIG_SIZE_VIEWPOINT_LLA; }
} PCIG_viewpoint_lla_type;


typedef struct pcig_viewport_struct {

   PCIG_header_type header;
   int viewpoint_id;              // PCIG_VIEWPOINT_XXXX
   float minx, maxx;              // (-1..1)
   float miny, maxy;              // (-1..1)
   int padd;

   pcig_viewport_struct() { header.type = PCIG_TYPE_VIEWPORT; header.size = PCIG_SIZE_VIEWPORT; }
} PCIG_viewport_type;


typedef struct pcig_channel_struct {

   PCIG_header_type header;
   int viewpoint_id;                // PCIG_VIEWPOINT_XXXX
   int mirror_state;                // 0 false, else true
   vector3f twist;                  // position of the channel relative to the forward axis of the eye (position/angle ??)
   vector2f shear;                  // linear offset of the channel relative to a normal drawn from the eye to the flat portion of the screen (units?)
   float horizontal_angular_offset; // radians - also defines shear x
   float vertical_angular_offset;   // radians - also defines shear y
   float aspect_distortion;         // linear factor used to correct for any non-linearities

   pcig_channel_struct() { header.type = PCIG_TYPE_CHANNEL; header.size = PCIG_SIZE_CHANNEL; }
} PCIG_channel_type;


typedef struct pcig_camera_struct {

   PCIG_header_type header;
   int viewpoint_id;                // PCIG_VIEWPOINT_XXXX
   int platform;                    // camera id (0..4)
   float aov;                       // total horizontal fov, radians
   float zoom;                      // zoom scale
   PCIG_position3d_type pos;        // meters offset from camera 0
   PCIG_orientation_type orient;    // radians offset from camera 0
   int padd;
   
   pcig_camera_struct() { header.type = PCIG_TYPE_CAMERA; header.size = PCIG_SIZE_CAMERA; }

} PCIG_camera_type;


typedef struct pcig_terrain_struct {

   PCIG_header_type header;
   int terrain_id;                // correlation w/ terrain.txt
   int padd;
   
   pcig_terrain_struct() { header.type = PCIG_TYPE_TERRAIN; header.size = PCIG_SIZE_TERRAIN; }

} PCIG_terrain_type;


typedef struct pcig_fog_struct {

   PCIG_header_type header;
   int viewpoint_id;         // PCIG_VIEWPOINT_XXXX
   int status;               // 0 = off, else on
   int type;                 // PCIG_FOG_XXX
   float near_plane, far_plane;  // start/opaque distance (meters)
   float scale;              // scale for distance
   vector3f rgb;             // color of fog
   int padd;
   
   pcig_fog_struct() { header.type = PCIG_TYPE_FOG; header.size = PCIG_SIZE_FOG; }

} PCIG_fog_type;


typedef struct pcig_fog2_struct {

   PCIG_header_type header;
   int viewpoint_id;         // PCIG_VIEWPOINT_XXXX
   int status;               // 0 = off, else on
   int type;                 // PCIG_FOG_XXX
   float near_plane, far_plane; // start/opaque distance (meters)
   float patchy_alt;         // altitude above fog that affects the viewing dist
   float alt;                // altitude for end of ground fog (MSL, meters)
   vector3f rgb;             // color of fog
   
   pcig_fog2_struct() { header.type = PCIG_TYPE_FOG2; header.size = PCIG_SIZE_FOG2; }

} PCIG_fog2_type;


typedef struct pcig_cloud_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int status;                   // 0 = off, else on
   int layer;                    // cloud layer (1..2)
   float start_alt, end_alt;     // lower/upper alt of cloud deck (meters msl)
   float visibility;             // visibility in meters
   float scud_lower, scud_upper; // how far below/above the cloud deck scud layer is active
   float scud_jitter;            // parameter (use -1 for system default)
   float scud_phase;             // parameter (use -1 for system default)
   
   pcig_cloud_struct() { header.type = PCIG_TYPE_CLOUD; header.size = PCIG_SIZE_CLOUD; }

} PCIG_cloud_type;


typedef struct pcig_cloud2_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int status;                   // 0 = off, else on
   int type;                     // (1)
   int layer;                    // cloud layer (1..2)
   int precipitation_type;       // PCIG_PRECIP_XXXX
   float start_alt, end_alt;     // lower/upper alt of cloud deck (meters msl)
   float density;                // amount of clouds (0..1)
   float visibility;             // visibility in meters
   float scud_lower, scud_upper; // how far below/above the cloud deck scud layer is active
   float scud_jitter;            // parameter (use -1 for system default)
   float scud_phase;             // parameter (use -1 for system default)
   float scud_radius;            // average radius of each cloud in the sky
   
   pcig_cloud2_struct() { header.type = PCIG_TYPE_CLOUD2; header.size = PCIG_SIZE_CLOUD2; }

} PCIG_cloud2_type;


typedef struct pcig_time_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int tom;                      // hhmm - military time (0000..2359)
   float elevation;              // max elevation of sun at noon
   float intensity;              // brightness of sun (0..1)
   
   pcig_time_struct() { header.type = PCIG_TYPE_TIME; header.size = PCIG_SIZE_TIME; }

} PCIG_time_type;


typedef struct pcig_time2_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int time_zone;                // (1..24)
   int daylight_savings;         // 0 = off, else on
   int year;                     // year at origin
   int month;                    // month at origin
   int day;                      // day at origin
   float time;                   // time at origin (units???)
   int padd;
   
   pcig_time2_struct() { header.type = PCIG_TYPE_TIME2; header.size = PCIG_SIZE_TIME2; }

} PCIG_time2_type;


typedef struct pcig_sky_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int status_flag;              // PCIG_SKY_XXXX
   vector3f rbg;                 // (0..1)
   float attenuation;            // amount of particulate matter (2.5..5.0)
   
   pcig_sky_struct() { header.type = PCIG_TYPE_SKY; header.size = PCIG_SIZE_SKY; }

} PCIG_sky_type;


typedef struct pcig_visibility_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   float visibility;             // range from eye that visibility should reach (meters)
   
   pcig_visibility_struct() { header.type = PCIG_TYPE_VISIBILITY; header.size = PCIG_SIZE_VISIBILITY; }

} PCIG_visibility_type;


typedef struct pcig_wind_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int status;                   // 0 = off, else on
   float speed;                  // knots
   float direction;              // compass direction - units- degrees???
   float gust_max;               // N/A
   float gust_freq;              // N/A
   
   pcig_wind_struct() { header.type = PCIG_TYPE_WIND; header.size = PCIG_SIZE_WIND; }

} PCIG_wind_type;


typedef struct pcig_runway_visual_range_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int status;                   // 0 = off, else on
   int runway;                   // entry into database (used for altitude calcs)
   int padd;                     // set to zero
   float visibility;             // actual RVR (meters)
   float end_alt;                // ceiling for effect above runway altitude
   
   pcig_runway_visual_range_struct() { header.type = PCIG_TYPE_RUNWAY_VISUAL_RANGE; header.size = PCIG_SIZE_RUNWAY_VISUAL_RANGE; }

} PCIG_runway_visual_range_type;


typedef struct pcig_entity_update_struct {

   PCIG_header_type header;
   int id;                          // (0..1000)
   int type;                        // correlate w/ config/models.txt
   PCIG_position3d_type pos;
   PCIG_orientation_type orient;    
   int padd;
   
   pcig_entity_update_struct() { header.type = PCIG_TYPE_ENTITY_UPDATE; header.size = PCIG_SIZE_ENTITY_UPDATE; }

} PCIG_entity_update_type;


typedef struct pcig_status_update_struct {

   PCIG_header_type header;
   int id;                          // (0..1000)
   int type;                        // correlate w/ config/models.txt
   int status;                      // PCIG_STATUS_XXXX
   vector3f scale;                  //
   PCIG_position3d_type pos;
   PCIG_orientation_type orient;    
   int padd;
   
   pcig_status_update_struct() { header.type = PCIG_TYPE_STATUS_UPDATE; header.size = PCIG_SIZE_STATUS_UPDATE; }

} PCIG_status_update_type;


typedef struct {

   // detatchment flag ???

   int id;                        // PCIG_ARTICULATION_XXXX
   PCIG_orientation_type orient;    
} PCIG_articulation_extention_type;  // 16 bytes


typedef struct pcig_articulation_head_struct {

   PCIG_header_type header;
   int id;                         // (0..1000)
   int count;                      // # of following PCIG_articulation_extention_type entries
   
   pcig_articulation_head_struct() { header.type = PCIG_TYPE_ARTICULATION; header.size = PCIG_SIZE_ARTICULATION_BASE; }

   // array of PCIG_articulation_extention_type

} PCIG_articulation_head_type;


typedef struct pcig_entity_articulation_head_struct {

   PCIG_header_type header;
   int id;                         // (0..1000)
   int type;                        // correlate w/ config/models.txt
   PCIG_position3d_type pos;
   PCIG_orientation_type orient;    
   int count;                      // # of following PCIG_articulation_extention_type entries
   
   pcig_entity_articulation_head_struct() { header.type = PCIG_TYPE_ENTITY_ARTICULATION_UPDATE; header.size = PCIG_SIZE_ENTITY_ARTICULATION_UPDATE_BASE; }

   // array of PCIG_articulation_extention_type

} PCIG_entity_articulation_head_type;


// spec is incomplete - unusable
typedef struct pcig_munitions_struct {

   PCIG_header_type header;
   int id;                         // (0..1000)
   int padd;
   
   pcig_munitions_struct() { header.type = PCIG_TYPE_MUNITIONS; header.size = PCIG_SIZE_MUNITIONS; }

} PCIG_munitions_type;


typedef struct pcig_entity_removal_struct {

   PCIG_header_type header;
   int id;                         // (0..1000)
   int padd;
   
   pcig_entity_removal_struct() { header.type = PCIG_TYPE_ENTITY_REMOVAL; header.size = PCIG_SIZE_ENTITY_REMOVAL; }

} PCIG_entity_removal_type;


typedef struct pcig_entity_lla_update_struct {

   PCIG_header_type header;
   int id;                          // (0..1000)
   int type;                        // correlate w/ config/models.txt
   PCIG_lla_type pos;
   PCIG_orientation_type orient;    
   int padd;
   
   pcig_entity_lla_update_struct() { header.type = PCIG_TYPE_ENTITY_LLA_UPDATE; header.size = PCIG_SIZE_ENTITY_LLA_UPDATE; }

} PCIG_entity_lla_update_type;


typedef struct pcig_status_update_lla_struct {

   PCIG_header_type header;
   int id;                          // (0..1000)
   int type;                        // correlate w/ config/models.txt
   int status;                      // PCIG_STATUS_XXXX
   vector3f scale;                  //
   PCIG_lla_type pos;
   PCIG_orientation_type orient;    
   int padd;
   
   pcig_status_update_lla_struct() { header.type = PCIG_TYPE_STATUS_UPDATE_LLA; header.size = PCIG_SIZE_STATUS_UPDATE_LLA; }

} PCIG_status_update_lla_type;


typedef struct pcig_sfx_struct {

   PCIG_header_type header;
   int type;                          // PCIG_SFX_TYPE_XXXX
   int subtype;                       // PCIG_SFX_SUBTYPE_XXXX_XXXX
   int attach;                        // (1 == attached to entity, else not)
   int id;                            // id of attached platform or sfx id
   int status;                        // 0 == off, else on (1)
   int clamp;                         // slap to the ground flag
   float duration;                    // (seconds)
   int padd;
   PCIG_position3d_type pos;
   
   pcig_sfx_struct() { header.type = PCIG_TYPE_SFX; header.size = PCIG_SIZE_SFX; }

} PCIG_sfx_type;


typedef struct pcig_sfx_lla_struct {

   PCIG_header_type header;
   int type;                          // PCIG_SFX_TYPE_XXXX
   int subtype;                       // PCIG_SFX_SUBTYPE_XXXX_XXXX
   int attach;                        // (1 == attached to entity, else not)
   int id;                            // id of attached platform or sfx id
   int status;                        // 0 == off, else on (1)
   int clamp;                         // slap to the ground flag
   float duration;                    // (seconds)
   int padd;
   PCIG_lla_type pos;
   
   pcig_sfx_lla_struct() { header.type = PCIG_TYPE_SFX_LLA; header.size = PCIG_SIZE_SFX_LLA; }

} PCIG_sfx_lla_type;


typedef struct pcig_runway_lights_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int count;                    // # of lights (1..999)
   int select;                   // PCIG_LIGHT_XXXX
   float intensity;              // (0..1)
   
   pcig_runway_lights_struct() { header.type = PCIG_TYPE_RUNWAY_LIGHTS; header.size = PCIG_SIZE_RUNWAY_LIGHTS; }

} PCIG_runway_lights_type;


typedef struct pcig_gfx_struct {

   PCIG_header_type header;
   int status;                   // PCIG_GFX_XXXX
   int padd;
   
   pcig_gfx_struct() { header.type = PCIG_TYPE_GFX; header.size = PCIG_SIZE_GFX; }

} PCIG_gfx_type;


typedef struct pcig_ogl_overlay_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int padd;

   // followed by user defined buffer
   
   pcig_ogl_overlay_struct() { header.type = PCIG_TYPE_OGL_OVERLAY; header.size = PCIG_SIZE_OGL_OVERLAY_BASE; }

} PCIG_ogl_overlay_type;


typedef struct {

   float x;        // (meters)
   float y;        // (meters)
   float rotation; // (radians???)
   float spare;
} PCIG_dof_type;


typedef struct {

   vector4i bitmask; // 64 length bitfield
} PCIG_switch_type;


typedef struct {

   char text[16];
} PCIG_text_type;


typedef struct {

   vector4f rgba;
} PCIG_rgba_type;


typedef struct {
   
   float xscale;
   float yscale;
   float spare[2];
} PCIG_scale_type;


typedef struct {

   char name[24];   // name of node in model
   int status;      // 0=off, 1=n
   int type;        // PCIG_OF_NODETYPE_XXXX

   union {
      PCIG_dof_type dof;
      PCIG_switch_type swtch;
      PCIG_text_type text;
      PCIG_rgba_type color;
      PCIG_scale_type scale;
   };

} PCIG_of_node_type;


typedef struct pcig_of_overlay_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int id;
   int type;
   int status;                   // 0=off, 1=on
   
   // followed by PCIG_of_node_type buffer
   
   pcig_of_overlay_struct() { header.type = PCIG_TYPE_OF_OVERLAY; header.size = PCIG_SIZE_OF_OVERLAY_BASE; }

} PCIG_of_overlay_type;


typedef struct pcig_sensor_select_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int type;                     // PCIG_SENSOR_TYPE_XXXX
      
   pcig_sensor_select_struct() { header.type = PCIG_TYPE_SENSOR_SELECT; header.size = PCIG_SIZE_SENSOR_SELECT; }

} PCIG_sensor_select_type;


typedef struct {

   int id;
   int padd;
   float emissivity; // (0..1)
   float temp;       // (0..1)
} PCIG_material_type;


typedef struct pcig_sensor_env_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int count;                    // count of PCIG_material_type (0..???)
   float humidity;               // (0..1)
   float ambient_temp;           // (deg Fahrenheit)
      
   pcig_sensor_env_struct() { header.type = PCIG_TYPE_SENSOR_ENV; header.size = PCIG_SIZE_SENSOR_ENV_BASE; }

   // followed by "count" of PCIG_material_type
   
} PCIG_sensor_env_type;


typedef struct pcig_sensor_characteristics_struct {

   PCIG_header_type header;
   int viewpoint_id;             // PCIG_VIEWPOINT_XXXX
   int polarity;                 // white(1)/black(0) hot values in sensor 
   int auto_gain;                // 0=off, 1=on
//   float ac_coupling;            // 0=off, 1=on
   int ac_coupling;              // 0=off, 1=on
   float contrast;               // (0..1)
   float sensitivity;            // (0..1)
   float blur;
   float saturation;
   float fixed_pattern_noise;    // (0..1)
   float random_noise;           // (0..1)
   PCIG_color_type color;        // alpha ignored
         
   pcig_sensor_characteristics_struct() { header.type = PCIG_TYPE_SENSOR_CHARACTERISTICS; header.size = PCIG_SIZE_SENSOR_CHARACTERISTICS; }
} PCIG_sensor_characteristics_type;


typedef struct pcig_remove_all_struct {

   PCIG_header_type header;
         
   pcig_remove_all_struct() { header.type = PCIG_TYPE_REMOVE_ALL; header.size = PCIG_SIZE_REMOVE_ALL; }
} PCIG_remove_all_type;


typedef struct pcig_lazer_range_find_struct {

   PCIG_header_type header;
   PCIG_position3d_type pos;        // start pt (meters)
   PCIG_orientation_type orient;    // direction to "look" (radians ???)
   int id;                          // id of response by host
         
   pcig_lazer_range_find_struct() { header.type = PCIG_TYPE_LAZER_RANGE_FIND; header.size = PCIG_SIZE_LAZER_RANGE_FIND; }
} PCIG_lazer_range_find_type;


typedef struct pcig_terrain_height_struct {

   PCIG_header_type header;
   int id;                          // id PCIG is to use to respond to this request
   int padd;
   PCIG_position3d_type pos;        // location to look for height (y is ignored in the request) (meters)
            
   pcig_terrain_height_struct() { header.type = PCIG_TYPE_TERRAIN_HEIGHT; header.size = PCIG_SIZE_TERRAIN_HEIGHT; }
} PCIG_terrain_height_type;


typedef struct pcig_geometric_intervisibility_struct {

   PCIG_header_type header;
   int count;                        // unique incrementing count used to identify the response
   int exclusion;                    // mask to define intervisibility check (PCIG_INTERVISIBILITY_XXXX)
   int agl1;                         // 0=msl, else agl
   int agl2;                         // 0=msl, else agl
   PCIG_position3d_type pos1;        // begin point (IG units and coordinate system)
   PCIG_position3d_type pos2;        // end point (IG units and coordinate system)
            
   pcig_geometric_intervisibility_struct() { header.type = PCIG_TYPE_GEOMETRIC_INTERVISIBILITY; header.size = PCIG_SIZE_GEOMETRIC_INTERVISIBILITY; }
} PCIG_geometric_intervisibility_type;


typedef struct pcig_terrain_height2_struct {

   PCIG_header_type header;
   int id;                          // id PCIG is to use to respond to this request
   int padd;
   PCIG_position3d_type pos;        // location to look for height (y is ignored in the request) (meters)
            
   pcig_terrain_height2_struct() { header.type = PCIG_TYPE_TERRAIN_HEIGHT2; header.size = PCIG_SIZE_TERRAIN_HEIGHT2; }
} PCIG_terrain_height2_type;


typedef struct pcig_frame_response_struct {

   PCIG_header_type header;
   int count;                        // supplied by the host at the beginning and end of the frame of data
   float frame_time;                 // time to render the frame
   double terrain_height;            // height of terrain under camera MSL (meters) - set if flag is set in the frame sync packet sent to the IG
            
   pcig_frame_response_struct() { header.type = PCIG_TYPE_FRAME_RESPONSE; header.size = PCIG_SIZE_FRAME_RESPONSE; }
} PCIG_frame_response_type;  // ReplyInfo


typedef struct pcig_lazer_range_find_response_struct {

   PCIG_header_type header;
   int id;                          // id of original request
   float range;                     // intersection range (meters)
   PCIG_position3d_type pos;        // intersection (meters)
   PCIG_orientation_type orient;    // orientation of the face that the intersection occured (surface normal orientation) (radians ???)
   int mat_id;                      // material code of the surface material
   int model_id;                    // -1 if miss, else model number
   int padd;
   
   pcig_lazer_range_find_response_struct() { header.type = PCIG_TYPE_LAZER_RANGE_FIND_RESPONSE; header.size = PCIG_SIZE_LAZER_RANGE_FIND_RESPONSE; }
} PCIG_lazer_range_find_response_type;  // LRFInfo


typedef struct pcig_terrain_height_response_struct {

   PCIG_header_type header;
   int id;                          // id from original request request
   float height;                    // response (meters)
            
   pcig_terrain_height_response_struct() { header.type = PCIG_TYPE_TERRAIN_HEIGHT_RESPONSE; header.size = PCIG_SIZE_TERRAIN_HEIGHT_RESPONSE; }
} PCIG_hot_response_type; // HOTInfo


typedef struct pcig_geometric_intervisibility_response_struct {

   PCIG_header_type header;
   int count;                       // id of request
   int intervisibility;             // 0=no intersect, 1=yes
   PCIG_position3d_type pos;        // intersection (IG units)
   PCIG_orientation_type orient;    // orientation of the face that the intersection occured (surface normal orientation) (radians ???)
   int mat_id;                      // material code of the surface material
   int model_id;                    // -1 if miss, else model number
   int padd;
   
   pcig_geometric_intervisibility_response_struct() { header.type = PCIG_TYPE_GEOMETRIC_INTERVISIBILITY_RESPONSE; header.size = PCIG_SIZE_GEOMETRIC_INTERVISIBILITY_RESPONSE; }
} PCIG_geometric_intervisibility_response_type; // GIInfo


typedef struct pcig_collision_detection_response_struct {

   PCIG_header_type header;
   int id1;                         // entity being updated (munition id)
   int id2;                         // other entity (-1 if terrain)
   int subid[6];                    // sub object in the model (gun, turrent, etc)
   int padd[3];
   PCIG_position3d_type pos;        // intersection (meters???)
   
   pcig_collision_detection_response_struct() { header.type = PCIG_TYPE_COLLISION_DETECTION_RESPONSE; header.size = PCIG_SIZE_COLLISION_DETECTION_RESPONSE; }
} PCIG_collision_detection_response_type; // CollisionInfo


typedef struct pcig_frame_response_detailed_struct {

   PCIG_header_type header;
   int count;                        // supplied by the host at the beginning and end of the frame of data
   int mat_id;                       // material code of the surface material on the polygon at the location
   float frame_time;                 // time to render the frame
   PCIG_orientation_type orient;     // orientation of the face under the camera
   double terrain_height;            // height of terrain under camera MSL (meters) - set if flag is set in the frame sync packet sent to the IG
            
   pcig_frame_response_detailed_struct() { header.type = PCIG_TYPE_FRAME_RESPONSE_DETAILED; header.size = PCIG_SIZE_FRAME_RESPONSE_DETAILED; }
} PCIG_frame_response_detailed_type; // ReplyDetailsInfo


typedef struct pcig_hot_response2_struct {

   PCIG_header_type header;
   int count;                        // supplied by the host at the beginning and end of the frame of data
   int mat_id;                       // material code of the surface material on the polygon at the location
   float frame_time;                 // time to render the frame
   PCIG_orientation_type orient;     // orientation of the face under the camera
   double terrain_height;            // height of terrain under camera MSL (meters) - set if flag is set in the frame sync packet sent to the IG
            
   pcig_hot_response2_struct() { header.type = PCIG_TYPE_TERRAIN_HEIGHT_RESPONSE2; header.size = PCIG_SIZE_TERRAIN_HEIGHT_RESPONSE2; }
} PCIG_hot_response2_type; // HOTDetailsInfo


typedef struct pcig_ready_to_render_struct {

   PCIG_header_type header;

   pcig_ready_to_render_struct() { header.type = PCIG_TYPE_READY_TO_RENDER; header.size = PCIG_SIZE_READY_TO_RENDER; }
} PCIG_ready_to_render_type;

#endif
